/*
 * (c) 2013 Ch. klippel  -  ck@atelier-klippel.de / c.klippel@gmx.de
 *
 * This code is released under the terms of the GPL, version 2 or newer.
 * See the file COPYING for more information about the license.
 *
 * Changelog:
 *
 * v00.01: - Initial version
 *
 */

#ifndef ADC_H
#define ADC_H

typedef union ADRESStruct
{
	unsigned short result;
	struct
	{
		unsigned char lo;
		unsigned char hi;
	};
} ADREStype;

typedef struct RFDataStruct
{
    unsigned short supply;
    unsigned short vf;
    unsigned short vr;
    unsigned short swr;
    float pwr;
} RFDataType;

#define FORWARD     0
#define REFLECTED   1
#define SUPPLY      2

#define ADC_MUTEX_RESULTS       0b00000001
#define ADC_MUTEX_DELTACALC     0b00000010


extern unsigned short adc_results_0[16], adc_results_1[16], adc_results_2[16];
extern unsigned char adc_idx;
extern unsigned char adc_chn;
extern ADREStype adc;

extern unsigned short adc_average_0, adc_average_1, adc_average_2;

extern volatile unsigned char adc_access_mutex;

extern RFDataType rf_data;

void adc_init(void);
//void adc_process(void);
unsigned short adc_get_reading(unsigned char which);
void adc_store_vfvr(void);
void calc_rf_data(void);

#endif
