/*
 * (c) 2013 Ch. klippel  -  ck@atelier-klippel.de / c.klippel@gmx.de
 *
 * This code is released under the terms of the GPL, version 2 or newer.
 * See the file COPYING for more information about the license.
 *
 * Changelog:
 *
 * v00.01: - Initial version
 *
 */

#include "rfsupply.h"

static unsigned short data_crc;

void config_manager_init(void)
{
    uart_print_start_msg(tr(S_CONFIG_MANAGER));

    config_manager_load_main_config();
    config_manager_load_config(main_config.config_num);
}

unsigned char config_manager_load_main_config(void)
{
    if(config_memory_load_main_config() == 0)
    {
        uart_print_module_msg(tr(S_CONFIG_MANAGER), tr(S_INVALID_MAINCFG));
        
        config_memory_default_main_config();
        config_memory_save_main_config();

        if(config_memory_load_main_config() == 0)
        {
            config_memory_default_main_config();
            return 0;
        }
        else
        {
            return 1;
        }

    }
}

unsigned char config_manager_load_config(unsigned char config_num)
{
    if(config_memory_load_config(config_num) == 0)
    {
        uart_print_module_msg(tr(S_CONFIG_MANAGER), tr(S_INVALID_CFG));

        config_memory_default_config();
        config_memory_save_config(config_num);

        if(config_memory_load_config(config_num) == 0)
        {
            config_memory_default_config();
            return 0;
        }
        else
        {
            return 1;
        }

    }
}

