/*
 * (c) 2013 Ch. klippel  -  ck@atelier-klippel.de / c.klippel@gmx.de
 *
 * This code is released under the terms of the GPL, version 2 or newer.
 * See the file COPYING for more information about the license.
 *
 * Changelog:
 *
 * v00.01: - Initial version
 *
 */

#include "rfsupply.h"

#pragma udata access _RENCODER_DATA 
near signed char encoder_val1;
near unsigned char time_encoder1;
near unsigned char state_encoder1;
near unsigned char old_state_encoder1;
near unsigned char temp_encoder;
near unsigned short step_encoder1;
near unsigned char cfg_encoder;
near unsigned char bcnt1;
near unsigned char bcnt2;
near unsigned char enc1_state;
near unsigned char enc2_state;

#pragma udata

union _ENC_BUTTON button_state_encoder1;

void encoder_init(void)
{
    uart_print_start_msg(tr(S_ROTARY_ENCODER));

    state_encoder1 = 0;
    state_encoder1 = enc1_state;
    old_state_encoder1 = state_encoder1;
    encoder_val1 = 0;
    time_encoder1 = 0;
    step_encoder1 = 1;
    cfg_encoder = 0b00000000;
    enc1_state = 0;
    bcnt1 = 0;
    bcnt2 = 0;
    process_encoder();
    encoder_val1 = 0;
    button_state_encoder1.enc_button_byte = 0x00;

    T0CON = 0b01000010;
    TMR0H = 0xFF;
    TMR0L = 0x00;
    INTCON2bits.TMR0IP = 0;
    INTCONbits.TMR0IF = 0;
    INTCONbits.TMR0IE = 1;
    T0CONbits.TMR0ON = 1;
}

signed char encoder_get(void)
{
	signed char tval;
	
	INTCONbits.TMR0IE = 0;
	tval = encoder_val1;
	encoder_val1 = 0;
	INTCONbits.TMR0IE = 1;
	
	return(tval);
}

unsigned char encoder_get_button(void)
{
	static unsigned char tval;
	
	INTCONbits.TMR0IE = 0;
	tval = button_state_encoder1.enc_button_byte;
	INTCONbits.TMR0IE = 1;
	
	return(tval);
}

void encoder_reset_button(void)
{
	INTCONbits.TMR0IE = 0;
	button_state_encoder1.enc_button_byte = 0x00;
	button_state_encoder1.encoder_reset = 1;
	INTCONbits.TMR0IE = 1;
}

void process_encoder(void)
{
    if(ENC1_K == 0)
        {
                if(!(button_state_encoder1.encoder_freeze))
                {
                        if(!(button_state_encoder1.encoder_pushed))
                        {
                                bcnt1 = 0;
                                bcnt2 = 0;
                                button_state_encoder1.encoder_pushed = 1;
                                button_state_encoder1.encoder_released = 0;
                        }

                        if(bcnt2 < 15)
                        {
                                bcnt1++;
                                if(bcnt1 == 0)
                                {
                                        bcnt2++;
                                }
                        }

                        if(bcnt2 == 15)
                        {
                                bcnt2++;
                                button_state_encoder1.encoder_longpushed = 1;
                                button_state_encoder1.encoder_freeze = 1;
                        }
                }
        }
        else
        {
                button_state_encoder1.encoder_released = 1;
                if(!(button_state_encoder1.encoder_freeze))
                {
                        if(button_state_encoder1.encoder_pushed)
                        {
                                bcnt1 = 0;
                                bcnt2 = 0;

                                if(button_state_encoder1.encoder_clicked)
                                {
                                        button_state_encoder1.encoder_doubleclicked = 1;
                                }

                                button_state_encoder1.encoder_clicked = 1;
                                button_state_encoder1.encoder_pushed = 0;
                        }

                        if(bcnt2 < 15)
                        {
                                bcnt1++;
                                if(bcnt1 == 0)
                                {
                                        bcnt2++;
                                }
                        }

                        if(bcnt2 == 3)
                        {
                                bcnt2++;
                                button_state_encoder1.encoder_freeze = 1;
                        }
                }

                if(button_state_encoder1.encoder_reset)
                {
                        button_state_encoder1.enc_button_byte = 0x00;
                }
        }

        enc1_state = 0;
        if(ENC1_A)
            enc1_state |= 0x02;
        if(ENC1_B)
            enc1_state |= 0x01;


        state_encoder1 = enc1_state;
        if(state_encoder1 != old_state_encoder1)
        {
                temp_encoder = old_state_encoder1;
                temp_encoder <<= 2;
                temp_encoder |= state_encoder1;

                switch(temp_encoder)
                {
                        case 0x01:
                        case 0x0E:
                                        if(encoder_val1 < 127)
                                        {
                                                if(button_state_encoder1.encoder_pushed)
                                                {
                                                        button_state_encoder1.encoder_rotated = 1;
                                                }
                                                encoder_val1 += 1;
                                        }
                                        break;
                        case 0x04:
                        case 0x0B:
                                        if(encoder_val1 > -127)
                                        {
                                                if(button_state_encoder1.encoder_pushed)
                                                {
                                                        button_state_encoder1.encoder_rotated = 1;
                                                }
                                                encoder_val1 -= 1;
                                        }
                                        break;
                        default:
                                        break;
                }
                old_state_encoder1 = state_encoder1;
        }

}