/*
 * (c) 2013 Ch. klippel  -  ck@atelier-klippel.de / c.klippel@gmx.de
 *
 * This code is released under the terms of the GPL, version 2 or newer.
 * See the file COPYING for more information about the license.
 *
 * Changelog:
 *
 * v00.01: - Initial version
 *
 */

#ifndef ENCODER_H
#define ENCODER_H

#define	ENCODER_RELEASED		0x01
#define	ENCODER_PUSHED			0x02
#define ENCODER_LONGPUSH		0x04
#define ENCODER_CLICKED			0x08
#define ENCODER_FREEZE			0x20
#define ENCODER_RESET_BUTTON	0x40
#define ENCODER_ROTATED			0x80

typedef union _ENC_BUTTON
{
	unsigned char	enc_button_byte;
	struct
	{
		unsigned char encoder_released:1;
		unsigned char encoder_pushed:1;
		unsigned char encoder_longpushed:1;
		unsigned char encoder_clicked:1;
		unsigned char encoder_doubleclicked:1;
		unsigned char encoder_freeze:1;
		unsigned char encoder_reset:1;
		unsigned char encoder_rotated:1;
	};
};

extern near signed char encoder_val1;
extern near unsigned char state_encoder1;
extern near unsigned char old_state_encoder1;
extern near unsigned char temp_encoder;
extern union _ENC_BUTTON button_state_encoder1;

void encoder_init(void);
signed char encoder_get(void);

unsigned char encoder_get_button(void);
void encoder_reset_button(void);

void process_encoder(void);

#endif
