/*
 * (c) 2013 Ch. klippel  -  ck@atelier-klippel.de / c.klippel@gmx.de
 *
 * This code is released under the terms of the GPL, version 2 or newer.
 * See the file COPYING for more information about the license.
 *
 * Changelog:
 *
 * v00.01: - Initial version
 *
 */

#ifndef MENUSTRINGS_H
#define MENUSTRINGS_H

#define tr(_X_)		current_strings[_X_]

typedef struct LANGUAGE_ENTRY {
    rom const void *data;
} LANGUAGE_ENTRY;

extern rom const struct LANGUAGE_ENTRY rom language_entries[];

#define NUM_LANGUAGES               2
#define LANG_ENGLISH                0
#define LANG_GERMAN                 1

#define S_LANGUAGE_NAME             0
#define S_INIT_MODULES              ( S_LANGUAGE_NAME           + 1 )
#define S_LANGUAGE_MANAGER          ( S_INIT_MODULES            + 1 )
#define S_SELECT_LANGUAGE           ( S_LANGUAGE_MANAGER        + 1 )
#define S_INVALID_LANGUAGE          ( S_SELECT_LANGUAGE         + 1 )
#define S_STARTING                  ( S_INVALID_LANGUAGE        + 1 )
#define S_LCD_DRIVER                ( S_STARTING                + 1 )
#define S_LCD_BACKLIGHT             ( S_LCD_DRIVER              + 1 )
#define S_CONFIG_MANAGER            ( S_LCD_BACKLIGHT           + 1 )
#define S_INVALID_MAINCFG           ( S_CONFIG_MANAGER          + 1 )
#define S_INVALID_CFG               ( S_INVALID_MAINCFG         + 1 )
#define S_CONFIG_MEMORY             ( S_INVALID_CFG             + 1 )
#define S_USING_INTMAINCFG          ( S_CONFIG_MEMORY           + 1 )
#define S_USING_INTCFG              ( S_USING_INTMAINCFG        + 1 )
#define S_USING_SAVEDMAINCFG        ( S_USING_INTCFG            + 1 )
#define S_USING_SAVEDCFG            ( S_USING_SAVEDMAINCFG      + 1 )
#define S_LOADED_CFG                ( S_USING_SAVEDCFG          + 1 )
#define S_SAVING_MAINCFG            ( S_LOADED_CFG              + 1 )
#define S_SAVING_CFG                ( S_SAVING_MAINCFG          + 1 )
#define S_CHECKSUM_OK               ( S_SAVING_CFG              + 1 )
#define S_CHECKSUM_WRONG            ( S_CHECKSUM_OK             + 1 )
#define S_TIP_DETECTOR              ( S_CHECKSUM_WRONG          + 1 )
#define S_ADC                       ( S_TIP_DETECTOR            + 1 )
#define S_RF_MANAGER                ( S_ADC                     + 1 )

#define S_POWER_MANAGER             ( S_RF_MANAGER              + 1 )
#define S_ROTARY_ENCODER            ( S_POWER_MANAGER           + 1 )
#define S_TIP_DETECTED              ( S_ROTARY_ENCODER          + 1 )
#define S_NO_TIP                    ( S_TIP_DETECTED            + 1 )
#define S_CHANGE_STATE              ( S_NO_TIP                  + 1 )
#define S_CHANGE_POWERLEVEL         ( S_CHANGE_STATE            + 1 )
#define S_OFF                       ( S_CHANGE_POWERLEVEL       + 1 )
#define S_NORMAL                    ( S_OFF                     + 1 )
#define S_LIMIT                     ( S_NORMAL                  + 1 )
#define S_BOOST                     ( S_LIMIT                   + 1 )
#define S_INVALID                   ( S_BOOST                   + 1 )
#define S_AFTER                     ( S_INVALID                 + 1 )
#define S_PM_STARTUP                ( S_AFTER                   + 1 )
#define S_PM_STARTUP_TIMED_LIMIT    ( S_PM_STARTUP              + 1 )
#define S_PM_STARTUP_SWR_LIMIT      ( S_PM_STARTUP_TIMED_LIMIT  + 1 )
#define S_PM_STARTUP_DELTA_LIMIT    ( S_PM_STARTUP_SWR_LIMIT    + 1 )
#define S_PM_STARTUP_TIMED_BOOST    ( S_PM_STARTUP_DELTA_LIMIT  + 1 )
#define S_PM_STARTUP_SWR_BOOST      ( S_PM_STARTUP_TIMED_BOOST  + 1 )
#define S_PM_STARTUP_DELTA_BOOST    ( S_PM_STARTUP_SWR_BOOST    + 1 )
#define S_PM_HEATING                ( S_PM_STARTUP_DELTA_BOOST  + 1 )
#define S_PM_HEATED                 ( S_PM_HEATING              + 1 )
#define S_PM_ENTER_IDLE             ( S_PM_HEATED               + 1 )
#define S_PM_IDLE                   ( S_PM_ENTER_IDLE           + 1 )
#define S_PM_ENTER_SLEEP            ( S_PM_IDLE                 + 1 )
#define S_PM_SLEEP                  ( S_PM_ENTER_SLEEP          + 1 )
#define S_PM_WAKEUP                 ( S_PM_SLEEP                + 1 )
#define S_PM_WAKEUP_TIMED_BOOST     ( S_PM_WAKEUP               + 1 )
#define S_PM_WAKEUP_SWR_BOOST       ( S_PM_WAKEUP_TIMED_BOOST   + 1 )
#define S_PM_WAKEUP_DELTA_BOOST     ( S_PM_WAKEUP_SWR_BOOST     + 1 )
#define S_PM_ENTER_POWERDOWN        ( S_PM_WAKEUP_DELTA_BOOST   + 1 )
#define S_PM_POWERDOWN              ( S_PM_ENTER_POWERDOWN      + 1 )
#define S_PM_MANUAL_OFF             ( S_PM_POWERDOWN            + 1 )
#define S_PM_MANUAL_LIMIT           ( S_PM_MANUAL_OFF           + 1 )
#define S_PM_MANUAL_NORMAL          ( S_PM_MANUAL_LIMIT         + 1 )
#define S_PM_MANUAL_BOOST           ( S_PM_MANUAL_NORMAL        + 1 )
#define S_PM_OFF                    ( S_PM_MANUAL_BOOST         + 1 )
#define S_HEATING                   ( S_PM_OFF                  + 1 )
#define S_READY                     ( S_HEATING                 + 1 )
#define S_IDLE                      ( S_READY                   + 1 )
#define S_ENTER_SLEEP               ( S_IDLE                    + 1 )
#define S_WAKEUP                    ( S_ENTER_SLEEP             + 1 )
#define S_MPOWER_OFF                ( S_WAKEUP                  + 1 )
#define S_MPOWER_LIMIT              ( S_MPOWER_OFF              + 1 )
#define S_MPOWER_NORMAL             ( S_MPOWER_LIMIT            + 1 )
#define S_MPOWER_BOOST              ( S_MPOWER_NORMAL           + 1 )

#endif
