/*
 * (c) 2013 Ch. klippel  -  ck@atelier-klippel.de / c.klippel@gmx.de
 *
 * This code is released under the terms of the GPL, version 2 or newer.
 * See the file COPYING for more information about the license.
 *
 * Changelog:
 *
 * v00.01: - Initial version
 *
 */

#ifndef POWER_MANAGER_H
#define	POWER_MANAGER_H

#define PM_STARTUP                   0
#define PM_STARTUP_TIMED_LIMIT       1
#define PM_STARTUP_SWR_LIMIT         2
#define PM_STARTUP_DELTA_LIMIT       3
#define PM_STARTUP_TIMED_BOOST       4
#define PM_STARTUP_SWR_BOOST         5
#define PM_STARTUP_DELTA_BOOST       6
#define PM_HEATING                   7
#define PM_HEATED                    8
#define PM_ENTER_IDLE                9
#define PM_IDLE                     10
#define PM_ENTER_SLEEP              11
#define PM_SLEEP                    12
#define PM_WAKEUP                   13
#define PM_WAKEUP_TIMED_BOOST       14
#define PM_WAKEUP_SWR_BOOST         15
#define PM_WAKEUP_DELTA_BOOST       16
#define PM_ENTER_POWERDOWN          17
#define PM_POWERDOWN                18
#define PM_MANUAL_OFF               19
#define PM_MANUAL_LIMIT             20
#define PM_MANUAL_NORMAL            21
#define PM_MANUAL_BOOST             22
#define PM_OFF                      23

#define PM_CFG_NONE                 0b00000000
#define PM_CFG_ENABLE_SLEEP         0b00000001
#define PM_CFG_ENABLE_POWERDOWN     0b00000010

#define PM_CFG_STARTUP_NORMAL       0b00000000
#define PM_CFG_STARTUP_LIMIT        0b00000001
#define PM_CFG_STARTUP_BOOST        0b00000010
#define PM_CFG_STARTUP_TIMED        0b00000100
#define PM_CFG_STARTUP_SWR          0b00001000
#define PM_CFG_STARTUP_DELTA        0b00010000

#define PM_CFG_WAKEUP_NORMAL        0b00000000
#define PM_CFG_WAKEUP_BOOST         0b00000001
#define PM_CFG_WAKEUP_TIMED         0b00000010
#define PM_CFG_WAKEUP_SWR           0b00000100
#define PM_CFG_WAKEUP_DELTA         0b00001000

void power_manager_init(void);
void power_manager_reset(void);
void power_manager_process(signed char user_input);

void power_manager_set_state(unsigned char new_state);
unsigned char power_manager_get_state(void);
const rom char* power_manager_get_state_string(unsigned char val);

void power_manager_set_config(unsigned char cfg);
void power_manager_set_sleeptime(unsigned short stime);

unsigned long power_manager_get_state_seconds(void);

#endif

