/*
 * (c) 2013 Ch. klippel  -  ck@atelier-klippel.de / c.klippel@gmx.de
 *
 * This code is released under the terms of the GPL, version 2 or newer.
 * See the file COPYING for more information about the license.
 *
 * Changelog:
 *
 * v00.01: - Initial version
 *
 */

#ifndef RF_MANAGER_H
#define RF_MANAGER_H

#define RF_POWER_OFF                0
#define RF_POWER_NORMAL             1
#define RF_POWER_BOOST              2
#define RF_POWER_LIMIT              3

void rf_manager_init(void);
void rf_manager_add_delta(void);
void rf_manager_store_delta(void);
void rf_manager_clear_delta(void);
void rf_manager_clear_all_delta(void);
unsigned short rf_manager_get_delta(void);
unsigned short rf_manager_get_delta_diff(void);
unsigned char rf_manager_has_delta(unsigned short delta);
unsigned short rf_manager_get_swr(void);
unsigned short rf_manager_get_pwr(unsigned char scale);
unsigned short rf_manager_get_supply(void);
void rf_manager_ticker(void);

void rf_manager_set_mode(unsigned char val);
unsigned char rf_manager_get_mode(void);
const rom char* rf_manager_get_mode_string(unsigned char val);

#endif

