/*
 * (c) 2013 Ch. klippel  -  ck@atelier-klippel.de / c.klippel@gmx.de
 *
 * This code is released under the terms of the GPL, version 2 or newer.
 * See the file COPYING for more information about the license.
 *
 * Changelog:
 *
 * v00.01: - Initial version
 *
 */

#ifndef UART_H
#define UART_H

void uart_init(void);

void uart_print_romstring(const rom char *str);
void uart_print_ramstring(char *str);
void uart_print_start_msg(const rom char *str);
void uart_print_module_msg(const rom char *mod_str, const rom char *msg_str);
void uart_print_module_msg_val(const rom char *mod_str, const rom char *msg_str, const rom char *val_str);
void uart_print_module_msg_ramval(const rom char *mod_str, const rom char *msg_str, char *val_str);
void uart_print_timed_change_msg(const rom char *mod_str, const rom char *msg_str, const rom char *state_str, unsigned long secs);
void uart_print_ushortnum(unsigned short num, unsigned char digits);
void uart_print_seconds_as_time(unsigned short seconds);
void uart_print_version(void);

#endif

